! ROSCO IO
! This file is automatically generated by write_registry.py using ROSCO v2.9.0
! For any modification to the registry, please edit the rosco_types.yaml accordingly
 
MODULE ROSCO_IO
    USE, INTRINSIC :: ISO_C_Binding
    USE ROSCO_Types
    USE ReadSetParameters
    USE Constants
IMPLICIT NONE

CONTAINS

SUBROUTINE WriteRestartFile(LocalVar, CntrPar, ErrVar, objInst, RootName, size_avcOUTNAME)
    TYPE(LocalVariables), INTENT(IN)                :: LocalVar
    TYPE(ControlParameters), INTENT(INOUT)          :: CntrPar
    TYPE(ObjectInstances), INTENT(INOUT)            :: objInst
    TYPE(ErrorVariables), INTENT(INOUT)             :: ErrVar
    INTEGER(IntKi), INTENT(IN)                      :: size_avcOUTNAME
    CHARACTER(size_avcOUTNAME), INTENT(IN)        :: RootName 
    
    INTEGER(IntKi)               :: Un                  ! I/O unit for pack/unpack (checkpoint & restart)
    INTEGER(IntKi)               :: I                   ! Generic index.
    CHARACTER(128)               :: InFile              ! Input checkpoint file
    INTEGER(IntKi)               :: ErrStat
    CHARACTER(128)               :: ErrMsg              
    CHARACTER(128)               :: n_t_global          ! timestep number as a string

    WRITE(n_t_global, '(I0.0)' ) NINT(LocalVar%Time/LocalVar%DT)
    InFile = TRIM(RootName)//TRIM( n_t_global )//'.RO.chkp'
    CALL GetNewUnit(Un, ErrVar)
    OPEN(unit=Un, FILE=TRIM(InFile), STATUS='UNKNOWN', FORM='UNFORMATTED' , ACCESS='STREAM', IOSTAT=ErrStat, ACTION='WRITE' )

    IF ( ErrStat /= 0 ) THEN
        ErrVar%aviFAIL = 1
        ErrVar%ErrMsg  = 'ROSCO_IO: Cannot open checkpoint file '//TRIM(InFile)//' for writing'

    ELSE
        WRITE( Un, IOSTAT=ErrStat) LocalVar%iStatus
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Time
        WRITE( Un, IOSTAT=ErrStat) LocalVar%DT
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WriteThisStep
        WRITE( Un, IOSTAT=ErrStat) LocalVar%n_DT
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Time_Last
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_GenPwr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_GenPwrF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenSpeed
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RotSpeed
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NacHeading
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NacVane
        WRITE( Un, IOSTAT=ErrStat) LocalVar%HorWindV
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitch(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitch(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitch(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%BlPitchCMeas
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Azimuth
        WRITE( Un, IOSTAT=ErrStat) LocalVar%OL_Azimuth
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AzUnwrapped
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AzError
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenTqAz
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AzBuffer(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AzBuffer(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NumBl
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_Acc
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NacIMU_FA_Acc
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_AccHPF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_AccHPFI
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_TSR
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_TRA
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_RL
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd_SS
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd_PRC
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RotSpeedF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenSpeedF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenTqMeas
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenArTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%GenBrTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_KP
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_KI
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_KD
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_TF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_MaxPit
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_MinPit
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_Last
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComTF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_PwrErr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_SpdErr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisTilt_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisYaw_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisTilt_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisYaw_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisTilt_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisYaw_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisYawF_1P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisTilt_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisYaw_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%axisYawF_2P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_KI(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_KI(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_KP(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_KP(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%IPC_IntSat
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PC_State
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitCom(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitComAct(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitComAct(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PitComAct(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SS_DelOmegaF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%TestType
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Kp_Float
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_MaxTq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenTrq
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenPwr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_MechGenPwr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErrAr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErrBr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErr
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_State
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_Rgn3Pitch
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_Vw
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_Vw_F
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_VwI
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE_VwIdot
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenTrqF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PRC_WSE_F
        WRITE( Un, IOSTAT=ErrStat) LocalVar%SD
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Fl_PitCom
        WRITE( Un, IOSTAT=ErrStat) LocalVar%NACIMU_FA_AccF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_AccF
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FA_Hist
        WRITE( Un, IOSTAT=ErrStat) LocalVar%TRA_LastRefSpd
        WRITE( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpeed
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTDX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTDY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTDZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRDX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRDY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRDZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTVX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTVY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTVZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRVX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRVY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRVZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTAX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTAY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmTAZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRAX
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRAY
        WRITE( Un, IOSTAT=ErrStat) LocalVar%PtfmRAZ
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(4)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(5)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(6)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(7)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(8)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(9)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(10)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(11)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(12)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(4)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(5)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(6)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(7)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(8)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(9)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(10)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(11)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(12)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(4)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(5)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(6)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(7)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(8)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(9)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(10)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(11)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(12)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(4)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(5)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(6)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(7)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(8)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(9)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(10)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(11)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%StC_Input(12)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ACC_INFILE_SIZE
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ACC_INFILE
        WRITE( Un, IOSTAT=ErrStat) LocalVar%restart
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_ID
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_YawOffset
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_TorqueOffset
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(1)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(2)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(3)
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%om_r
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%v_t
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%v_m
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%v_h
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%P
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%xh
        WRITE( Un, IOSTAT=ErrStat) LocalVar%WE%K
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_b1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_InputSignalLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_OutputSignalLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%hpf_InputSignalLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%hpf_OutputSignalLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_b2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_OutputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_OutputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_InputSignalLast1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_InputSignalLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_a1
        WRITE( Un, IOSTAT=ErrStat) LocalVar%FP%nf_a0
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ITerm
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ITermLast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ITerm2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ITermLast2
        WRITE( Un, IOSTAT=ErrStat) LocalVar%piP%ELast
        WRITE( Un, IOSTAT=ErrStat) LocalVar%rlP%LastSignal
        WRITE( Un, IOSTAT=ErrStat) objInst%instLPF
        WRITE( Un, IOSTAT=ErrStat) objInst%instSecLPF
        WRITE( Un, IOSTAT=ErrStat) objInst%instSecLPFV
        WRITE( Un, IOSTAT=ErrStat) objInst%instHPF
        WRITE( Un, IOSTAT=ErrStat) objInst%instNotchSlopes
        WRITE( Un, IOSTAT=ErrStat) objInst%instNotch
        WRITE( Un, IOSTAT=ErrStat) objInst%instPI
        WRITE( Un, IOSTAT=ErrStat) objInst%instRL
        Close ( Un )
        IF ( ErrStat /= 0 ) THEN
            ErrVar%aviFAIL = 1
            ErrVar%ErrMsg  = 'ROSCO_IO: Error writing checkpoint file.'
        ENDIF
    ENDIF
END SUBROUTINE WriteRestartFile

 
SUBROUTINE ReadRestartFile(avrSWAP, LocalVar, CntrPar, objInst, PerfData, RootName, size_avcOUTNAME, ErrVar)
    TYPE(LocalVariables), INTENT(INOUT)             :: LocalVar
    TYPE(ControlParameters), INTENT(INOUT)          :: CntrPar
    TYPE(ObjectInstances), INTENT(INOUT)            :: objInst
    TYPE(PerformanceData), INTENT(INOUT)            :: PerfData
    TYPE(ErrorVariables), INTENT(INOUT)             :: ErrVar
    REAL(ReKi), INTENT(IN)                          :: avrSWAP(*)
    INTEGER(IntKi), INTENT(IN)                      :: size_avcOUTNAME
    CHARACTER(size_avcOUTNAME), INTENT(IN)        :: RootName 
    
    INTEGER(IntKi)               :: Un                  ! I/O unit for pack/unpack (checkpoint & restart)
    INTEGER(IntKi)               :: I                   ! Generic index.
    CHARACTER(128)               :: InFile              ! Input checkpoint file
    INTEGER(IntKi)               :: ErrStat
    CHARACTER(128)               :: ErrMsg              
    CHARACTER(128)               :: n_t_global          ! timestep number as a string

    WRITE(n_t_global, '(I0.0)' ) NINT(avrSWAP(2)/avrSWAP(3))
    InFile = TRIM(RootName)//TRIM( n_t_global )//'.RO.chkp'
    CALL GetNewUnit(Un, ErrVar)
    OPEN(unit=Un, FILE=TRIM(InFile), STATUS='UNKNOWN', FORM='UNFORMATTED' , ACCESS='STREAM', IOSTAT=ErrStat, ACTION='READ' )

    IF ( ErrStat /= 0 ) THEN
        ErrVar%aviFAIL = 1
        ErrVar%ErrMsg  = 'ROSCO_IO: Cannot open checkpoint file '//TRIM(InFile)//' for reading'

    ELSE
        READ( Un, IOSTAT=ErrStat) LocalVar%iStatus
        READ( Un, IOSTAT=ErrStat) LocalVar%Time
        READ( Un, IOSTAT=ErrStat) LocalVar%DT
        READ( Un, IOSTAT=ErrStat) LocalVar%WriteThisStep
        READ( Un, IOSTAT=ErrStat) LocalVar%n_DT
        READ( Un, IOSTAT=ErrStat) LocalVar%Time_Last
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_GenPwr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_GenPwrF
        READ( Un, IOSTAT=ErrStat) LocalVar%GenSpeed
        READ( Un, IOSTAT=ErrStat) LocalVar%RotSpeed
        READ( Un, IOSTAT=ErrStat) LocalVar%NacHeading
        READ( Un, IOSTAT=ErrStat) LocalVar%NacVane
        READ( Un, IOSTAT=ErrStat) LocalVar%HorWindV
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOP(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%rootMOOPF(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitch(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitch(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitch(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%BlPitchCMeas
        READ( Un, IOSTAT=ErrStat) LocalVar%Azimuth
        READ( Un, IOSTAT=ErrStat) LocalVar%OL_Azimuth
        READ( Un, IOSTAT=ErrStat) LocalVar%AzUnwrapped
        READ( Un, IOSTAT=ErrStat) LocalVar%AzError
        READ( Un, IOSTAT=ErrStat) LocalVar%GenTqAz
        READ( Un, IOSTAT=ErrStat) LocalVar%AzBuffer(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%AzBuffer(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%NumBl
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_Acc
        READ( Un, IOSTAT=ErrStat) LocalVar%NacIMU_FA_Acc
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_AccHPF
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_AccHPFI
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_PitCom(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_TSR
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_TRA
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpd_RL
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd_SS
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_RefSpd_PRC
        READ( Un, IOSTAT=ErrStat) LocalVar%RotSpeedF
        READ( Un, IOSTAT=ErrStat) LocalVar%GenSpeedF
        READ( Un, IOSTAT=ErrStat) LocalVar%GenTq
        READ( Un, IOSTAT=ErrStat) LocalVar%GenTqMeas
        READ( Un, IOSTAT=ErrStat) LocalVar%GenArTq
        READ( Un, IOSTAT=ErrStat) LocalVar%GenBrTq
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_PitComF(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_KP
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_KI
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_KD
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_TF
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_MaxPit
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_MinPit
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_Last
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComTF
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PitComT_IPC(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_PwrErr
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_SpdErr
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisTilt_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisYaw_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisTilt_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_AxisYaw_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisTilt_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisYaw_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisYawF_1P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisTilt_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisYaw_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%axisYawF_2P
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_KI(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_KI(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_KP(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_KP(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%IPC_IntSat
        READ( Un, IOSTAT=ErrStat) LocalVar%PC_State
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitCom(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitComAct(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitComAct(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%PitComAct(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%SS_DelOmegaF
        READ( Un, IOSTAT=ErrStat) LocalVar%TestType
        READ( Un, IOSTAT=ErrStat) LocalVar%Kp_Float
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_MaxTq
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenTrq
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenPwr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_MechGenPwr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErrAr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErrBr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_SpdErr
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_State
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_Rgn3Pitch
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_Vw
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_Vw_F
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_VwI
        READ( Un, IOSTAT=ErrStat) LocalVar%WE_VwIdot
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_LastGenTrqF
        READ( Un, IOSTAT=ErrStat) LocalVar%PRC_WSE_F
        READ( Un, IOSTAT=ErrStat) LocalVar%SD
        READ( Un, IOSTAT=ErrStat) LocalVar%Fl_PitCom
        READ( Un, IOSTAT=ErrStat) LocalVar%NACIMU_FA_AccF
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_AccF
        READ( Un, IOSTAT=ErrStat) LocalVar%FA_Hist
        READ( Un, IOSTAT=ErrStat) LocalVar%TRA_LastRefSpd
        READ( Un, IOSTAT=ErrStat) LocalVar%VS_RefSpeed
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTDX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTDY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTDZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRDX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRDY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRDZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTVX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTVY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTVZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRVX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRVY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRVZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTAX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTAY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmTAZ
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRAX
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRAY
        READ( Un, IOSTAT=ErrStat) LocalVar%PtfmRAZ
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(4)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(5)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(6)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(7)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(8)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(9)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(10)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(11)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_DesiredL(12)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(4)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(5)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(6)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(7)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(8)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(9)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(10)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(11)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedL(12)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(4)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(5)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(6)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(7)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(8)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(9)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(10)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(11)
        READ( Un, IOSTAT=ErrStat) LocalVar%CC_ActuatedDL(12)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(4)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(5)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(6)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(7)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(8)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(9)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(10)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(11)
        READ( Un, IOSTAT=ErrStat) LocalVar%StC_Input(12)
        READ( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%Flp_Angle(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%RootMyb_Last(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%ACC_INFILE_SIZE
        ALLOCATE(LocalVar%ACC_INFILE(LocalVar%ACC_INFILE_SIZE))
        READ( Un, IOSTAT=ErrStat) LocalVar%ACC_INFILE
        READ( Un, IOSTAT=ErrStat) LocalVar%restart
        READ( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%AWC_complexangle(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_ID
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_YawOffset
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_TorqueOffset
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(1)
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(2)
        READ( Un, IOSTAT=ErrStat) LocalVar%ZMQ_PitOffset(3)
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%om_r
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%v_t
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%v_m
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%v_h
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%P
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%xh
        READ( Un, IOSTAT=ErrStat) LocalVar%WE%K
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_b1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_InputSignalLast
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf1_OutputSignalLast
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpf2_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%lpfV_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%hpf_InputSignalLast
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%hpf_OutputSignalLast
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_b2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nfs_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_OutputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_OutputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_InputSignalLast1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_InputSignalLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b2
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_b0
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_a1
        READ( Un, IOSTAT=ErrStat) LocalVar%FP%nf_a0
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ITerm
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ITermLast
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ITerm2
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ITermLast2
        READ( Un, IOSTAT=ErrStat) LocalVar%piP%ELast
        READ( Un, IOSTAT=ErrStat) LocalVar%rlP%LastSignal
        READ( Un, IOSTAT=ErrStat) objInst%instLPF
        READ( Un, IOSTAT=ErrStat) objInst%instSecLPF
        READ( Un, IOSTAT=ErrStat) objInst%instSecLPFV
        READ( Un, IOSTAT=ErrStat) objInst%instHPF
        READ( Un, IOSTAT=ErrStat) objInst%instNotchSlopes
        READ( Un, IOSTAT=ErrStat) objInst%instNotch
        READ( Un, IOSTAT=ErrStat) objInst%instPI
        READ( Un, IOSTAT=ErrStat) objInst%instRL
        Close ( Un )
        IF ( ErrStat /= 0 ) THEN
            ErrVar%aviFAIL = 1
            ErrVar%ErrMsg  = 'ROSCO_IO: Error reading checkpoint file.'
        ENDIF
    ENDIF
    ! Read Parameter files
    CALL ReadControlParameterFileSub(CntrPar, LocalVar, LocalVar%ACC_INFILE, LocalVar%ACC_INFILE_SIZE, RootName, ErrVar)
    IF (CntrPar%WE_Mode > 0) THEN
        CALL READCpFile(CntrPar, PerfData, ErrVar)
    ENDIF
END SUBROUTINE ReadRestartFile

 
SUBROUTINE Debug(LocalVar, CntrPar, DebugVar, ErrVar, avrSWAP, RootName, size_avcOUTNAME)
! Debug routine, defines what gets printed to DEBUG.dbg if LoggingLevel = 1

    TYPE(ControlParameters), INTENT(IN) :: CntrPar
    TYPE(LocalVariables), INTENT(IN) :: LocalVar
    TYPE(DebugVariables), INTENT(IN) :: DebugVar
    TYPE(ErrorVariables),       INTENT(INOUT)   :: ErrVar

    INTEGER(IntKi), INTENT(IN)      :: size_avcOUTNAME
    INTEGER(IntKi)                  :: I , nDebugOuts, nLocalVars   ! Generic index.
    CHARACTER(1), PARAMETER         :: Tab = CHAR(9)                ! The tab character.
    CHARACTER(100)                  :: FmtDat                       ! The format of the debugging data
    INTEGER(IntKi), SAVE            :: UnDb                         ! I/O unit for the debugging information
    INTEGER(IntKi), SAVE            :: UnDb2                        ! I/O unit for the debugging information, avrSWAP
    INTEGER(IntKi), SAVE            :: UnDb3                        ! I/O unit for the debugging information, avrSWAP
    REAL(ReKi), INTENT(INOUT)       :: avrSWAP(*)                   ! The swap array, used to pass data to, and receive data from, the DLL controller.
    CHARACTER(size_avcOUTNAME), INTENT(IN) :: RootName            ! a Fortran version of the input C string (not considered an array here)    [subtract 1 for the C null-character]
    CHARACTER(200)                  :: Version                      ! git version of ROSCO
    CHARACTER(15), ALLOCATABLE      :: DebugOutStrings(:), DebugOutUnits(:)

    ! Avr output writing
    INTEGER(IntKi), SAVE, DIMENSION(:), ALLOCATABLE     :: avrIndices
    INTEGER(IntKi)                  :: avrBaseLength = 85
    INTEGER(IntKi)                  :: Ind
    CHARACTER(100)                  :: avrFmt

    REAL(DbKi), ALLOCATABLE         :: DebugOutData(:)
 
    CHARACTER(15), ALLOCATABLE      :: LocalVarOutStrings(:)
    REAL(DbKi), ALLOCATABLE         :: LocalVarOutData(:)
 
    nDebugOuts = 26
    Allocate(DebugOutData(nDebugOuts))
    Allocate(DebugOutStrings(nDebugOuts))
    Allocate(DebugOutUnits(nDebugOuts))
    DebugOutData(1) = DebugVar%WE_Cp
    DebugOutData(2) = DebugVar%WE_b
    DebugOutData(3) = DebugVar%WE_w
    DebugOutData(4) = DebugVar%WE_t
    DebugOutData(5) = DebugVar%WE_Vm
    DebugOutData(6) = DebugVar%WE_Vt
    DebugOutData(7) = DebugVar%WE_Vw
    DebugOutData(8) = DebugVar%WE_lambda
    DebugOutData(9) = DebugVar%PC_PICommand
    DebugOutData(10) = DebugVar%GenSpeedF
    DebugOutData(11) = DebugVar%RotSpeedF
    DebugOutData(12) = DebugVar%NacIMU_FA_AccF
    DebugOutData(13) = DebugVar%FA_AccF
    DebugOutData(14) = DebugVar%Fl_PitCom
    DebugOutData(15) = DebugVar%PC_MinPit
    DebugOutData(16) = DebugVar%axisTilt_1P
    DebugOutData(17) = DebugVar%axisYaw_1P
    DebugOutData(18) = DebugVar%axisTilt_2P
    DebugOutData(19) = DebugVar%axisYaw_2P
    DebugOutData(20) = DebugVar%YawRateCom
    DebugOutData(21) = DebugVar%NacHeadingTarget
    DebugOutData(22) = DebugVar%NacVaneOffset
    DebugOutData(23) = DebugVar%Yaw_Err
    DebugOutData(24) = DebugVar%YawState
    DebugOutData(25) = DebugVar%VS_RefSpd
    DebugOutData(26) = DebugVar%PC_RefSpd
    DebugOutStrings = [CHARACTER(15) ::  'WE_Cp', 'WE_b', 'WE_w', 'WE_t', 'WE_Vm', & 
                                      'WE_Vt', 'WE_Vw', 'WE_lambda', 'PC_PICommand', 'GenSpeedF', & 
                                      'RotSpeedF', 'NacIMU_FA_AccF', 'FA_AccF', 'Fl_PitCom', 'PC_MinPit', & 
                                      'axisTilt_1P', 'axisYaw_1P', 'axisTilt_2P', 'axisYaw_2P', 'YawRateCom', & 
                                      'NacHeadingTarget', 'NacVaneOffset', 'Yaw_Err', 'YawState', 'VS_RefSpd', & 
                                      'PC_RefSpd']
    DebugOutUnits = [CHARACTER(15) ::  '[-]', '[-]', '[-]', '[-]', '[m/s]', & 
                                      '[m/s]', '[m/s]', '[rad]', '[rad]', '[rad/s]', & 
                                      '[rad/s]', '[rad/s]', '[m/s]', '[rad]', '[rad]', & 
                                      '[N/A]', '[N/A]', '[N/A]', '[N/A]', '[rad/s]', & 
                                      '[deg]', '[deg]', '[deg]', '[N/A]', '[rad/s]', & 
                                      '[rad/s]']
    nLocalVars = 124
    Allocate(LocalVarOutData(nLocalVars))
    Allocate(LocalVarOutStrings(nLocalVars))
    LocalVarOutData(1) = LocalVar%iStatus
    LocalVarOutData(2) = LocalVar%Time
    LocalVarOutData(3) = LocalVar%DT
    LocalVarOutData(4) = LocalVar%n_DT
    LocalVarOutData(5) = LocalVar%Time_Last
    LocalVarOutData(6) = LocalVar%VS_GenPwr
    LocalVarOutData(7) = LocalVar%VS_GenPwrF
    LocalVarOutData(8) = LocalVar%GenSpeed
    LocalVarOutData(9) = LocalVar%RotSpeed
    LocalVarOutData(10) = LocalVar%NacHeading
    LocalVarOutData(11) = LocalVar%NacVane
    LocalVarOutData(12) = LocalVar%HorWindV
    LocalVarOutData(13) = LocalVar%rootMOOP(1)
    LocalVarOutData(14) = LocalVar%rootMOOPF(1)
    LocalVarOutData(15) = LocalVar%BlPitch(1)
    LocalVarOutData(16) = LocalVar%BlPitchCMeas
    LocalVarOutData(17) = LocalVar%Azimuth
    LocalVarOutData(18) = LocalVar%OL_Azimuth
    LocalVarOutData(19) = LocalVar%AzUnwrapped
    LocalVarOutData(20) = LocalVar%AzError
    LocalVarOutData(21) = LocalVar%GenTqAz
    LocalVarOutData(22) = LocalVar%AzBuffer(1)
    LocalVarOutData(23) = LocalVar%NumBl
    LocalVarOutData(24) = LocalVar%FA_Acc
    LocalVarOutData(25) = LocalVar%NacIMU_FA_Acc
    LocalVarOutData(26) = LocalVar%FA_AccHPF
    LocalVarOutData(27) = LocalVar%FA_AccHPFI
    LocalVarOutData(28) = LocalVar%FA_PitCom(1)
    LocalVarOutData(29) = LocalVar%VS_RefSpd
    LocalVarOutData(30) = LocalVar%VS_RefSpd_TSR
    LocalVarOutData(31) = LocalVar%VS_RefSpd_TRA
    LocalVarOutData(32) = LocalVar%VS_RefSpd_RL
    LocalVarOutData(33) = LocalVar%PC_RefSpd
    LocalVarOutData(34) = LocalVar%PC_RefSpd_SS
    LocalVarOutData(35) = LocalVar%PC_RefSpd_PRC
    LocalVarOutData(36) = LocalVar%RotSpeedF
    LocalVarOutData(37) = LocalVar%GenSpeedF
    LocalVarOutData(38) = LocalVar%GenTq
    LocalVarOutData(39) = LocalVar%GenTqMeas
    LocalVarOutData(40) = LocalVar%GenArTq
    LocalVarOutData(41) = LocalVar%GenBrTq
    LocalVarOutData(42) = LocalVar%IPC_PitComF(1)
    LocalVarOutData(43) = LocalVar%PC_KP
    LocalVarOutData(44) = LocalVar%PC_KI
    LocalVarOutData(45) = LocalVar%PC_KD
    LocalVarOutData(46) = LocalVar%PC_TF
    LocalVarOutData(47) = LocalVar%PC_MaxPit
    LocalVarOutData(48) = LocalVar%PC_MinPit
    LocalVarOutData(49) = LocalVar%PC_PitComT
    LocalVarOutData(50) = LocalVar%PC_PitComT_Last
    LocalVarOutData(51) = LocalVar%PC_PitComTF
    LocalVarOutData(52) = LocalVar%PC_PitComT_IPC(1)
    LocalVarOutData(53) = LocalVar%PC_PwrErr
    LocalVarOutData(54) = LocalVar%PC_SpdErr
    LocalVarOutData(55) = LocalVar%IPC_AxisTilt_1P
    LocalVarOutData(56) = LocalVar%IPC_AxisYaw_1P
    LocalVarOutData(57) = LocalVar%IPC_AxisTilt_2P
    LocalVarOutData(58) = LocalVar%IPC_AxisYaw_2P
    LocalVarOutData(59) = LocalVar%axisTilt_1P
    LocalVarOutData(60) = LocalVar%axisYaw_1P
    LocalVarOutData(61) = LocalVar%axisYawF_1P
    LocalVarOutData(62) = LocalVar%axisTilt_2P
    LocalVarOutData(63) = LocalVar%axisYaw_2P
    LocalVarOutData(64) = LocalVar%axisYawF_2P
    LocalVarOutData(65) = LocalVar%IPC_KI(1)
    LocalVarOutData(66) = LocalVar%IPC_KP(1)
    LocalVarOutData(67) = LocalVar%IPC_IntSat
    LocalVarOutData(68) = LocalVar%PC_State
    LocalVarOutData(69) = LocalVar%PitCom(1)
    LocalVarOutData(70) = LocalVar%PitComAct(1)
    LocalVarOutData(71) = LocalVar%SS_DelOmegaF
    LocalVarOutData(72) = LocalVar%TestType
    LocalVarOutData(73) = LocalVar%Kp_Float
    LocalVarOutData(74) = LocalVar%VS_MaxTq
    LocalVarOutData(75) = LocalVar%VS_LastGenTrq
    LocalVarOutData(76) = LocalVar%VS_LastGenPwr
    LocalVarOutData(77) = LocalVar%VS_MechGenPwr
    LocalVarOutData(78) = LocalVar%VS_SpdErrAr
    LocalVarOutData(79) = LocalVar%VS_SpdErrBr
    LocalVarOutData(80) = LocalVar%VS_SpdErr
    LocalVarOutData(81) = LocalVar%VS_State
    LocalVarOutData(82) = LocalVar%VS_Rgn3Pitch
    LocalVarOutData(83) = LocalVar%WE_Vw
    LocalVarOutData(84) = LocalVar%WE_Vw_F
    LocalVarOutData(85) = LocalVar%WE_VwI
    LocalVarOutData(86) = LocalVar%WE_VwIdot
    LocalVarOutData(87) = LocalVar%VS_LastGenTrqF
    LocalVarOutData(88) = LocalVar%PRC_WSE_F
    LocalVarOutData(89) = LocalVar%Fl_PitCom
    LocalVarOutData(90) = LocalVar%NACIMU_FA_AccF
    LocalVarOutData(91) = LocalVar%FA_AccF
    LocalVarOutData(92) = LocalVar%FA_Hist
    LocalVarOutData(93) = LocalVar%TRA_LastRefSpd
    LocalVarOutData(94) = LocalVar%VS_RefSpeed
    LocalVarOutData(95) = LocalVar%PtfmTDX
    LocalVarOutData(96) = LocalVar%PtfmTDY
    LocalVarOutData(97) = LocalVar%PtfmTDZ
    LocalVarOutData(98) = LocalVar%PtfmRDX
    LocalVarOutData(99) = LocalVar%PtfmRDY
    LocalVarOutData(100) = LocalVar%PtfmRDZ
    LocalVarOutData(101) = LocalVar%PtfmTVX
    LocalVarOutData(102) = LocalVar%PtfmTVY
    LocalVarOutData(103) = LocalVar%PtfmTVZ
    LocalVarOutData(104) = LocalVar%PtfmRVX
    LocalVarOutData(105) = LocalVar%PtfmRVY
    LocalVarOutData(106) = LocalVar%PtfmRVZ
    LocalVarOutData(107) = LocalVar%PtfmTAX
    LocalVarOutData(108) = LocalVar%PtfmTAY
    LocalVarOutData(109) = LocalVar%PtfmTAZ
    LocalVarOutData(110) = LocalVar%PtfmRAX
    LocalVarOutData(111) = LocalVar%PtfmRAY
    LocalVarOutData(112) = LocalVar%PtfmRAZ
    LocalVarOutData(113) = LocalVar%CC_DesiredL(1)
    LocalVarOutData(114) = LocalVar%CC_ActuatedL(1)
    LocalVarOutData(115) = LocalVar%CC_ActuatedDL(1)
    LocalVarOutData(116) = LocalVar%StC_Input(1)
    LocalVarOutData(117) = LocalVar%Flp_Angle(1)
    LocalVarOutData(118) = LocalVar%RootMyb_Last(1)
    LocalVarOutData(119) = LocalVar%ACC_INFILE_SIZE
    LocalVarOutData(120) = LocalVar%AWC_complexangle(1)
    LocalVarOutData(121) = LocalVar%ZMQ_ID
    LocalVarOutData(122) = LocalVar%ZMQ_YawOffset
    LocalVarOutData(123) = LocalVar%ZMQ_TorqueOffset
    LocalVarOutData(124) = LocalVar%ZMQ_PitOffset(1)
    LocalVarOutStrings = [CHARACTER(15) ::  'iStatus', 'Time', 'DT', 'n_DT', 'Time_Last', & 
                                      'VS_GenPwr', 'VS_GenPwrF', 'GenSpeed', 'RotSpeed', 'NacHeading', & 
                                      'NacVane', 'HorWindV', 'rootMOOP', 'rootMOOPF', 'BlPitch', & 
                                      'BlPitchCMeas', 'Azimuth', 'OL_Azimuth', 'AzUnwrapped', 'AzError', & 
                                      'GenTqAz', 'AzBuffer', 'NumBl', 'FA_Acc', 'NacIMU_FA_Acc', & 
                                      'FA_AccHPF', 'FA_AccHPFI', 'FA_PitCom', 'VS_RefSpd', 'VS_RefSpd_TSR', & 
                                      'VS_RefSpd_TRA', 'VS_RefSpd_RL', 'PC_RefSpd', 'PC_RefSpd_SS', 'PC_RefSpd_PRC', & 
                                      'RotSpeedF', 'GenSpeedF', 'GenTq', 'GenTqMeas', 'GenArTq', & 
                                      'GenBrTq', 'IPC_PitComF', 'PC_KP', 'PC_KI', 'PC_KD', & 
                                      'PC_TF', 'PC_MaxPit', 'PC_MinPit', 'PC_PitComT', 'PC_PitComT_Last', & 
                                      'PC_PitComTF', 'PC_PitComT_IPC', 'PC_PwrErr', 'PC_SpdErr', 'IPC_AxisTilt_1P', & 
                                      'IPC_AxisYaw_1P', 'IPC_AxisTilt_2P', 'IPC_AxisYaw_2P', 'axisTilt_1P', 'axisYaw_1P', & 
                                      'axisYawF_1P', 'axisTilt_2P', 'axisYaw_2P', 'axisYawF_2P', 'IPC_KI', & 
                                      'IPC_KP', 'IPC_IntSat', 'PC_State', 'PitCom', 'PitComAct', & 
                                      'SS_DelOmegaF', 'TestType', 'Kp_Float', 'VS_MaxTq', 'VS_LastGenTrq', & 
                                      'VS_LastGenPwr', 'VS_MechGenPwr', 'VS_SpdErrAr', 'VS_SpdErrBr', 'VS_SpdErr', & 
                                      'VS_State', 'VS_Rgn3Pitch', 'WE_Vw', 'WE_Vw_F', 'WE_VwI', & 
                                      'WE_VwIdot', 'VS_LastGenTrqF', 'PRC_WSE_F', 'Fl_PitCom', 'NACIMU_FA_AccF', & 
                                      'FA_AccF', 'FA_Hist', 'TRA_LastRefSpd', 'VS_RefSpeed', 'PtfmTDX', & 
                                      'PtfmTDY', 'PtfmTDZ', 'PtfmRDX', 'PtfmRDY', 'PtfmRDZ', & 
                                      'PtfmTVX', 'PtfmTVY', 'PtfmTVZ', 'PtfmRVX', 'PtfmRVY', & 
                                      'PtfmRVZ', 'PtfmTAX', 'PtfmTAY', 'PtfmTAZ', 'PtfmRAX', & 
                                      'PtfmRAY', 'PtfmRAZ', 'CC_DesiredL', 'CC_ActuatedL', 'CC_ActuatedDL', & 
                                      'StC_Input', 'Flp_Angle', 'RootMyb_Last', 'ACC_INFILE_SIZE', 'AWC_complexangle', & 
                                      'ZMQ_ID', 'ZMQ_YawOffset', 'ZMQ_TorqueOffset', 'ZMQ_PitOffset']
    ! Initialize debug file
    IF ((LocalVar%iStatus == 0) .OR. (LocalVar%iStatus == -9))  THEN ! .TRUE. if we're on the first call to the DLL
        IF (CntrPar%LoggingLevel > 0) THEN
            CALL GetNewUnit(UnDb, ErrVar)
            OPEN(unit=UnDb, FILE=TRIM(RootName)//'.RO.dbg')
            WRITE(UnDb, *)  'Generated on '//CurDate()//' at '//CurTime()//' using ROSCO-'//TRIM(rosco_version)
            WRITE(UnDb, '(99(a20,TR5:))') 'Time',   DebugOutStrings
            WRITE(UnDb, '(99(a20,TR5:))') '(sec)',  DebugOutUnits
        END IF

        IF (CntrPar%LoggingLevel > 1) THEN
            CALL GetNewUnit(UnDb2, ErrVar)
            OPEN(unit=UnDb2, FILE=TRIM(RootName)//'.RO.dbg2')
            WRITE(UnDb2, *)  'Generated on '//CurDate()//' at '//CurTime()//' using ROSCO-'//TRIM(rosco_version)
            WRITE(UnDb2, '(125(a20,TR5:))') 'Time',   LocalVarOutStrings
            WRITE(UnDb2, '(125(a20,TR5:))')
        END IF

        IF (CntrPar%LoggingLevel > 2) THEN
            ! Set avrIndices, start with basic indices
            Allocate(avrIndices(avrBaseLength))
            DO Ind = 1, avrBaseLength
                avrIndices(Ind) = Ind
            END DO

            ! Cable control indices
            IF (CntrPar%CC_Mode > 0) THEN
                DO Ind = 1, SIZE(CntrPar%CC_GroupIndex)
                    Call AddToList(avrIndices,CntrPar%CC_GroupIndex(Ind))
                    Call AddToList(avrIndices,CntrPar%CC_GroupIndex(Ind)+1)
                END DO
            END IF

            ! Structural control indices
            IF (CntrPar%StC_Mode > 0) THEN
                DO Ind = 1, SIZE(CntrPar%StC_GroupIndex)
                    Call AddToList(avrIndices,CntrPar%StC_GroupIndex(Ind))
                END DO
            END IF

            ! Format string
            avrFmt = '(A21,'//TRIM(Int2LStr(SIZE(avrIndices)))//'(TR12,"'//'AvrSWAP(",I4,")"))'

            CALL GetNewUnit(UnDb3, ErrVar)
            OPEN(unit=UnDb3, FILE=TRIM(RootName)//'.RO.dbg3')
            WRITE(UnDb3,'(/////)')
            WRITE(UnDb3,avrFmt)  'LocalVar%Time ', (avrIndices)
            WRITE(UnDb3,'(A21,'//TRIM(Int2LStr(SIZE(avrIndices)))//'(TR22,"(-)"))')  '(s)'
        END IF
    END IF

        ! Print simulation status, every 10 seconds
    IF (MODULO(LocalVar%Time, 10.0_DbKi) == 0) THEN
        WRITE(*, 100) LocalVar%GenSpeedF*RPS2RPM, LocalVar%BlPitch(1)*R2D, avrSWAP(15)/1000.0, LocalVar%WE_Vw
        100 FORMAT('Generator speed: ', f6.1, ' RPM, Pitch angle: ', f5.1, ' deg, Power: ', f7.1, ' kW, Est. wind Speed: ', f5.1, ' m/s')
    END IF

    ! Process DebugOutData, LocalVarOutData
    ! Remove very small numbers that cause ******** outputs
    DO I = 1,SIZE(DebugOutData)
        IF (ABS(DebugOutData(I)) < 1E-99) THEN
            DebugOutData(I) = 0
        END IF
        IF (ABS(DebugOutData(I)) > 1E+99) THEN
            DebugOutData(I) = 1E+99
        END IF
    END DO
    
    DO I = 1,SIZE(LocalVarOutData)
        IF (ABS(LocalVarOutData(I)) < 1E-99) THEN
            LocalVarOutData(I) = 0
        END IF
        IF (ABS(LocalVarOutData(I)) > 1E+99) THEN
            LocalVarOutData(I) = 1E+99
        END IF
    END DO
    
    ! Write debug files
    FmtDat = "(F20.5,TR5,124(ES20.5E2,TR5:))"   ! The format of the debugging data
    IF ( MOD(LocalVar%n_DT, CntrPar%n_DT_Out) == 0) THEN
        IF(CntrPar%LoggingLevel > 0) THEN
            WRITE (UnDb, TRIM(FmtDat))  LocalVar%Time, DebugOutData
        END IF

        IF(CntrPar%LoggingLevel > 1) THEN
            WRITE (UnDb2, TRIM(FmtDat))  LocalVar%Time, LocalVarOutData
        END IF

        IF(CntrPar%LoggingLevel > 2) THEN
            WRITE (UnDb3, TRIM(FmtDat))    LocalVar%Time, avrSWAP(avrIndices)
        END IF
    END IF

    ! Close all files when simulation finished
    IF (LocalVar%iStatus < 0) THEN
        CLOSE(UnDb)
        CLOSE(UnDb2)
        CLOSE(UnDb3)
    ENDIF
END SUBROUTINE Debug

END MODULE ROSCO_IO